#ifndef _COURSE_H
#define _COURSE_H

#include <string>
#include <fstream>

using namespace std;

class Course
{
public:
   enum { cCodeSz = 8, cTitleSz = 80, cCategSz = 4  };
   Course( string aCode="" );
   const char* getCode() const {  return cCode;  }
   unsigned int getWH() const {  return cWH;  }
   unsigned int getNoOfStudents() const {  return cNoOfStudents;  }
   void setCode( string aCode );
   void setTitle( string aTitle );
   void setFSem( int aFSem );
   void setCompuls( bool aCompuls ) { cCompuls = aCompuls; };
   void setSector( char aSector )  {  cSector = aSector;  };
   void setCateg( string aCateg );
   void setWH( int aWH )  {  cWH = aWH;  };
   void setUnits( int aUnits )  {  cUnits = aUnits;  };
   void setPrereq( const string& prCode );
   void clearStudents() {  cNoOfStudents = 0;  }
   void add1Student() {  ++cNoOfStudents;  }
   void save( ostream& bout ) const;
   void load( istream& bin );
   void display( ostream& tout ) const;
private:
   enum { cSaveSize = cCodeSz + cTitleSz + sizeof(int) +
                      sizeof(bool)+ sizeof(char) + cCategSz +
                      sizeof(int) + sizeof(int) + cCodeSz +
                      sizeof(int) };
   char         cCode[cCodeSz];   //  
   char         cTitle[cTitleSz]; //  
   unsigned int cFSem;            //  
   bool         cCompuls;         //   
   char         cSector;          // 
   char         cCateg[cCategSz]; // 
   unsigned int cWH;              //   
   unsigned int cUnits;           //  
   char         cPrereq[cCodeSz]; // 
   unsigned int cNoOfStudents;    // . 
}; // Course

typedef Course*  PCourse;

struct CourseXptn
{
   enum {  rangeError, autoRef,
           fileNotOpen, cannotWrite, cannotRead  };
   char methodName[100];
   int  errorCode;
   int  errIntVal;
   char errStrVal[100];
   CourseXptn( const char* mn, int ec, const char* sv="" )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      errorCode = ec;
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  }
   CourseXptn( const char* mn, int ec, int iv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      errorCode = ec;
      errIntVal = iv;  }
}; // CourseXptn

#endif // _COURSE_H
